
import java.sql.*;
import java.net.*;
import java.io.*;
import java.lang.*;
import java.util.*;
import sun.server.http.*;
import java.servlet.*;
import java.servlet.http.*;


public class localSer extends HttpServlet {

	private Hashtable vConnection = new Hashtable(1);

      private int curConnectionCount = 1;
	private int connectionSpan = 1;


  private int exeTableDelete(Connection con,String table){

       Statement stmt;
       ResultSet rs;
       StringBuffer buf;
       int updateCount =0;
       boolean ret = false;

       try {
          System.out.println("inside delete table in localSer");
          stmt = con.createStatement();
          buf = new StringBuffer();
          buf.append("drop table "+table+";");
     
          System.out.println("sql :"+buf);
          ret = stmt.execute(new String(buf)); 

          if (ret == true){ 
             rs = stmt.getResultSet(); 
          } 
          else{ 
             updateCount = stmt.getUpdateCount(); 
             
          } 
          return updateCount; 
        } catch(Exception e){ 
          System.out.println(e); 
          return 0; 
        }
  }


  private int exeTableCreate(Connection con,Vector vColumnName,
                             Vector vTypeName,Vector vColumnSize,Vector vIsNullable,String table){

       // EXECUTE SQL 
       boolean ret = false; 
       ResultSet results = null; 
       int i,updateCount = 0; 
       StringBuffer buf;

       try { 
          Statement stmt = con.createStatement();
          buf = new StringBuffer();
          buf.append("create table"+table+"(");
          int size = vColumnName.size();
          for (i=0;i< size;i++){
              if(isNull((String)(vColumnSize.elementAt(i)))){
                 buf.append((String)(vColumnName.elementAt(i)));
                 buf.append("  ");
                 buf.append((String)(vTypeName.elementAt(i)));
              }
              else {
                 buf.append((String)(vColumnName.elementAt(i)));
                 buf.append("  ");
                 buf.append((String)(vTypeName.elementAt(i)));
                 buf.append("(");
                 buf.append((String)(vColumnSize.elementAt(i)));
                 buf.append(")");
              }
             if(((String)(vIsNullable.elementAt(i))).equalsIgnoreCase("no")){
                 buf.append("NOT NULL");
             }

             if(i+1 < size)
                 buf.append(" ,");
             
          }
          buf.append(");");
          System.out.println("sql :"+buf);
          ret = stmt.execute(new String(buf)); 
          if (ret == true){ 
             results = stmt.getResultSet(); 
          } 
          else{ 
             updateCount = stmt.getUpdateCount(); 
             
          } 
          return updateCount; 
        } catch(Exception e){ 
          System.out.println(e); 
          return 0; 
        } 
  }



  private int findInactiveId(Hashtable h ,int span){
      int i;
      for(i=1;i<=span;i++){
         if(!(h.containsKey((new Integer(i)).toString()))) {
           System.out.println(" id found :"+i);
           return i;
         }
      }
      return (span+1);

  }



  private void handleTables(HttpServletRequest req,HttpServletResponse res,String q){

        Hashtable ht = get_hashed(q);
        String url = (String)ht.get("url");
        String dbtype = (String)ht.get("dbtype");
        int tmpId;
        Connection con;
        DataOutputStream sout;

        try {

            if( dbtype.equalsIgnoreCase("odbc")){
   	        Driver d=(Driver)Class.forName("sun.jdbc.odbc.JdbcOdbcDriver").newInstance();
            }
            else {
              if( dbtype.equalsIgnoreCase("oracle")) {
             System.out.println("loading driver oci");
             Driver d=(Driver)Class.forName("weblogic.jdbc.oci.Driver").newInstance();
             }
            }

            if(curConnectionCount > connectionSpan) {
              connectionSpan = connectionSpan * 2;
              System.out.println("connectionSpan ="+connectionSpan);
              tmpId = curConnectionCount;
            }  
            else {
              System.out.println("in else");
              if( curConnectionCount < (connectionSpan/2)){
                 connectionSpan = connectionSpan/2;
              }
              tmpId = findInactiveId(vConnection ,connectionSpan);
              System.out.println(" found id  ="+tmpId);
            }
            
            con = connect(url,"udayan","udayan");
            //coneect to the database and keep the cnnection alive
            vConnection.put((new Integer(tmpId)).toString(),con);

            //obtain output stream to the applet
            sout = new DataOutputStream(res.getOutputStream()); 
            // write out conid
            sout.writeBytes((new Integer(tmpId)).toString()+"\r\n");

            // GET DB META DATA 
            DatabaseMetaData dmd;
            try {
                 System.out.println("before getting metadata");
                 dmd = con.getMetaData();
                 System.out.println("After getting metadata");
                // META DATA - GET TABLES 
                ResultSet results;
                
                String[] tttest = new String[5];
                tttest[0] = "TABLE";      
                results = dmd.getTables(null,null,"%",tttest);
                 System.out.println("After getting tables");
                // GET ALL RESULTS 
        
                  while(results.next()) {
                    String currTable = results.getString("TABLE_NAME");
                    System.out.println("Table is :"+currTable);

		        // META DATA - GET COLUMNS 
                    ResultSet results_columns;
                    try {
                      results_columns = dmd.getColumns(null,null,currTable,"%");
                      System.out.println("after getting columns");
                      // GET ALL RESULTS 
                      StringBuffer buf = new StringBuffer();
                         buf.append("table="+currTable+"\r\n");
                         while (results_columns.next()){
                           /*buf.append("COLUMN_NAME="+results_columns.getString("COLUMN_NAME"));
                           buf.append("&TYPE_NAME="+results_columns.getString("TYPE_NAME"));
                           buf.append("&COLUMN_SIZE="+results_columns.getString("COLUMN_SIZE"));
                           buf.append("&IS_NULLABLE="+results_columns.getString("IS_NULLABLE"));*/

                           buf.append("COLUMN_NAME="+results_columns.getString(4));
                           buf.append("&TYPE_NAME="+results_columns.getString(6));
                           buf.append("&COLUMN_SIZE="+results_columns.getString(8));
                           buf.append("&IS_NULLABLE="+results_columns.getString(11));

                           buf.append("\r\n");
                          }
                          // write the details for one table
                          System.out.println(" table details: ="+buf);
                          sout.writeBytes(new String(buf));
                          sout.flush();
                          results_columns.close();
            
                    }
                    catch(SQLException e) {
                       System.out.println(e);
                    }
                    catch(Exception e){
                       System.out.println(e);
                    }
                    System.out.println(" next table");
                  }  // end of while for getting the table names 
                  //sout.writeBytes("\r\n");
                  System.out.println("after reading all tables");
                  results.close();
                  //disconnect(con);
                  sout.writeBytes("END\r\n");
                  System.out.println("After writing END");
                  sout.flush();
                  sout.close();
                  System.out.println("after closing sout");
                
            } 
            catch (SQLException e){
               e.printStackTrace();
               System.out.println(e);
            }
            catch (IOException e) {
               System.out.println(e);
            }
            catch (Exception e) {
               System.out.println(e);
            }
        }
        catch(SQLException e){
           e.printStackTrace();
	  }
	  catch(Exception e){
           e.printStackTrace();
	  }
  }


  private void handleCreateTable(HttpServletRequest req,HttpServletResponse res,String q){

     DataInputStream din;
     DataOutputStream dout;
     Vector vColumnName;
     Vector vTypeName;
     Vector vColumnSize;
     Vector vIsNullable;

     String currLine="";
     Hashtable ht;
     try {
        din = new DataInputStream(req.getInputStream());
        dout = new DataOutputStream(res.getOutputStream());

        vColumnName = new Vector(10);
        vTypeName = new Vector(10);
        vColumnSize = new Vector(10);
        vIsNullable = new Vector(10);
        ht = get_hashed(q);

        String conid = (String)ht.get("conid");
        String table = (String)ht.get("table");

        Connection con = (Connection) vConnection.get(conid);
        // read details about the table 
     
        while ((currLine = din.readLine()) != null){
             ht = get_hashed(currLine);
            // fill in vectors 
            vColumnName.addElement((String)ht.get("COLUMN_NAME"));
            vTypeName.addElement((String)ht.get("TYPE_NAME"));
            vColumnSize.addElement((String)ht.get("COLUMN_SIZE"));
            vIsNullable.addElement((String)ht.get("IS_NULLABLE"));
        }
        // perform query creating the table
        int status = exeTableCreate(con,vColumnName,vTypeName,vColumnSize,vIsNullable,table);
        dout.writeBytes((new Integer(status)).toString());
        dout.flush();
        dout.close();
        din.close();
      }
      catch(IOException e){
        e.printStackTrace();
      }
      catch(Exception e){
        e.printStackTrace();
      }
   
  }

 private void handleDeleteTable(HttpServletRequest req,HttpServletResponse res,String q){
      
     DataOutputStream dout;

      try {
          
          dout = new DataOutputStream(res.getOutputStream());
          // read the dbname 
          Hashtable ht = get_hashed(q);
          String conid = (String)ht.get("conid");
          String table = (String)ht.get("table");

          Connection con = (Connection) vConnection.get(conid);

          // perform query creating the table
          int status = exeTableDelete(con,table);
          dout.writeBytes((new Integer(status)).toString());
          dout.flush();
          dout.close();
       }
       catch(IOException e){
        e.printStackTrace();
       }
  }



  // checks whether the string is null
  private boolean isNull(String s){
	if(s.equalsIgnoreCase(""))
		return true;
	else 
            return false;
  }

  // gets the value for  key from a hashtable
  private Hashtable get_hashed(String s){
	HttpUtils smutils;
	Hashtable h;
	try {
		smutils = new HttpUtils();
            System.out.println("in get_hashed "+s);
      	h=smutils.parseQueryString(s);
		return h;
	}
	catch(Exception e){
            e.printStackTrace();
		return null;
	}
  }

  // Encodes special characters so that there are no ambiguitie while sending data

  private String getEncoded(String str) {

    String per = "%25";
    String amp = "%26";
    String equ = "%3d";
    String newline = "+\n";
    String st = str.replace(' ','+');
    String finstr = "";
    StringBuffer sbuf = new StringBuffer();
    for (int i = 0; i < st.length(); i++) {
        char c = st.charAt(i);
        switch(c)  {
        case '%':
            sbuf.append(per);	
            break;
        case '&':
            sbuf.append(amp);	
            break;
        case '=':
            sbuf.append(equ);	
            break;
		case '\n':
			sbuf.append(newline);
			break;
        default :
            sbuf.append(c);	
            break;
        }
    }
    return (new String(sbuf));
  }                        


  // given resultset and a datatype returns the field value specified by the col
  private String getvalue(ResultSet rs,int datatype,int col) 
 	throws SQLException{

	String value="";
	int tp = 1;

	switch(datatype) {
	case Types.DATE:
	  java.sql.Date date = rs.getDate(col);
	  value = date.toString();
	  break;
	case Types.TIME:
	  java.sql.Time time = rs.getTime(col);
	  value = time.toString();
	  break;
	case Types.TIMESTAMP:
	  java.sql.Timestamp timestamp = rs.getTimestamp(col);
	  value = timestamp.toString();
	  break;
	case Types.CHAR:
	case Types.VARCHAR:
	case Types.LONGVARCHAR:
	  value = rs.getString(col);	
	  break;
	case Types.BIT:
	  boolean bit = rs.getBoolean(col);
	  value = (new Boolean(bit)).toString();
	  break;
	case Types.INTEGER:
	  int integer = rs.getInt(col);
 	  Integer ind = new Integer(integer);
	  value = ind.toString();
	  break;
	case Types.BIGINT:
	  long bigint = rs.getLong(col);
	  Long lng = new Long (bigint);
	  value =  lng.toString();
	  break;
	case Types.REAL:
	  float real = rs.getFloat(col);
	  value = (new Float(real)).toString();
	  break;
	case Types.FLOAT:
	case Types.DOUBLE:
	  double longreal = rs.getDouble(col);
	  value = (new Double(longreal)).toString();
	  break;
	} 
	if (value == null ) {
		value = "";
		return value;
	}else {
	String fin = getEncoded(value);
	return fin;
    }
  }


  // Connect to a database given url,user,password
  private Connection connect(String url,String user, String passwd) throws SQLException {

	Connection conn;
	try {
	// Attempt to connect to a driver.  Each one
	// of the registered drivers will be loaded until
	// one is found that can process this URL
	conn = DriverManager.getConnection (url, user, passwd);
      System.out.println("After successful connection");
	return conn;
 	}
	catch (SQLException ex) {
		// A SQLException was generated.  Catch it and
		// display the error information.  Note that there
		// could be multiple error objects chained
		// together

		System.out.println ("\n*** SQLException caught ***\n");
		while (ex != null) {
			System.out.println ("SQLState: " +
				ex.getSQLState ());
			System.out.println ("Message:  " +
				ex.getMessage ());
			System.out.println ("Vendor:   " +
				ex.getErrorCode ());
			ex = ex.getNextException ();
			System.out.println ("");
 		}
            throw ex;  // rethrow the exception
	}
	catch (java.lang.Exception ex) {
		// Got some other type of exception.  Dump it.
		ex.printStackTrace ();
	}
	return null;
  }


  private boolean disconnect(Connection c) throws SQLException {
    boolean rc= true;
	try{
		c.close();
            System.out.println("Connection closed");
	}
	catch(SQLException ex){
			// A SQLException was generated.  Catch it and
			// display the error information.  Note that there
			// could be multiple error objects chained
			// together

			System.out.println ("\n*** SQLException caught ***\n");

			while (ex != null) {
				System.out.println ("SQLState: " +
					ex.getSQLState ());
				System.out.println ("Message:  " +
					ex.getMessage ());
				System.out.println ("Vendor:   " +
					ex.getErrorCode ());
				ex = ex.getNextException ();
				System.out.println ("");
			}
                  throw ex; // rethrow the exception
	}
    return rc;
  }


//-------------------------------------------------------------------
// checkForWarning
// Checks for and displays warnings.  Returns true if a warning
// existed
//-------------------------------------------------------------------

  private static boolean checkForWarning (SQLWarning warn) throws SQLException {
	boolean rc = false;
		// If a SQLWarning object was given, display the
		// warning messages.  Note that there could be
		// multiple warnings chained together

	if (warn != null) {
		System.out.println ("\n *** Warning ***\n");
		rc = true;
		while (warn != null) {
			System.out.println ("SQLState: " +
				warn.getSQLState ());
			System.out.println ("Message:  " +
				warn.getMessage ());
			System.out.println ("Vendor:   " +
				warn.getErrorCode ());
			System.out.println ("");
			warn = warn.getNextWarning ();
		}
	}
	return rc;
  }



  public void service(HttpServletRequest req,HttpServletResponse res) throws ServletException, IOException {
      String qStr;
    System.out.println("Inside localDBServlet...");
	qStr = req.getQueryString();
    System.out.println("Inside localDBServlet...###"+ qStr);
	
      if((req.getMethod()).equals("POST")){
         System.out.println("In localDBServlet POST");
         if(qStr.equalsIgnoreCase("CREATETABLE")) {
             handleCreateTable(req,res,qStr);
         }
	}
      else {  // method is GET , display applet on the page
         System.out.println("Inside get");
         if(qStr.startsWith("GETTABLES")) {
			System.out.println("The queryString is "+qStr);
			handleTables(req,res,qStr);
         }
         else if(qStr.startsWith("DELETETABLE")){
			System.out.println("The queryString is "+qStr);
			handleDeleteTable(req,res,qStr);
         }
         else {
          System.out.println("Inside no query string"); 
	        PrintStream out = new PrintStream(res.getOutputStream());
		  out.println("<html><title> Error Page </title>");
		  out.println("<body bgcolor=white>");
		  out.println("<p><center><font size=3>");
		  out.println("Wrong Option or Bad request !<br>");
		  out.println("Please try again.");
		  out.println("</body></html>");
		  out.flush();
		  System.out.println("Came inside Get method");
		}
      }

  }


} // end of localDBServlet class


